%FreakLab - handleset.m
%
%Erstellt von Matthias Hasewend im Rahmen der bung 'Applikationssoftware
%fr Fortgeschrittene' bei Ass. Prof. Winfried Kernbichler, Institut fr
%Theoretische Physik / Computational Physics an der TU Graz im WS 2010/11.
%
%Beschreibung:
%
%Dieses Skript wird benutzt, um die Default-handle-Werte fr alle
%Bedienfelder bei Programmstart zu setzten oder um sie im Programmablauf
%wieder rckzusetzen.

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function handles = handleset(hObject,handles,num)

    %Aktion fr Hauptprogramm
    if(num == 0)

        handles.output = hObject;
        
        %Hauptbild
        handles.image = 1;
        %Preview-Bild
        handles.imtiny = 1;
        %Neues Bild
        handles.imnew = 1;
        %Bildname
        handles.imname = '';
        %Bildgre
        handles.imsize = [0,0];
        
        %Koordinaten des Cursors auf dem groen Anzeigefeld. Wird von
        %motion und FreakLab_opt2 verwendet zum anklicken der
        %Nullstelle / des Zentrums der Holomorphen Abbildung
        handles.cpoint = [0,0];

    %Aktion fr Bedienfeld 1
    elseif(num == 1)

        %Lineare Transformationsmatrix
        handles.afftra = [1,0;0,1];

    %Aktion fr Bedienfeld 2
    elseif(num == 2)

        %Bild- und Urbild-Zoomfaktor
        handles.uv = 1;
        handles.xy = 1;

        %Jede Zeile dieser Matrix bedeutet Vorfaktor, Re und Im der
        %Nullstelle und Exponent eines Summanden der Holomorphen Abbildung
        handles.holtra = [[1,0,0,1];repmat([0,0,0,1],8,1)];
        %Zhler, welche Zeile gerade angezeigt ist
        handles.holtrac = 1;
        %Zhler, wie viele Zeilen es gibt
        handles.trafos = 1;

        %periodische Fortsetzung aktiv oder inaktiv
        handles.per = 0;
        
        set(handles.popupmenu1,'String','Summand 1','Value',1);

    %Aktion fr Bedienfeld 3
    elseif(num == 3)
        
        %Bild- und Urbild-Zoomfaktor
        handles.uv = 1;
        handles.xy = 1;

        %Jede Zeile dieser Zelle bedeutet eine Zeile der Formel der
        %komplexen Abbildung
        handles.holtra = cell(9,1);
        %Default: Identittsabbildung in erster Zeile
        handles.holtra(1) = {'x'};
        %Zhler, welche Zeile gerade angezeigt ist
        handles.holtrac = 1;
        %Zhler, wie viele Zeilen es gibt
        handles.trafos = 1;
        %Zhler, wie lange die aktuelle Formelzeile ist (Anzahl an Zeichen)
        handles.rowleng = 0;

        %periodische Fortsetzung aktiv oder inaktiv
        handles.per = 0;

        set(handles.popupmenu2,'Value',1);
        set(handles.popupmenu3,'String','Zeile 1','Value',1);
        set(handles.edit18,'String','x');
       
    %Aktion fr Bedienfeld 4
    elseif(num == 4)
        
        %Indizes der Farbkanalvertauschung: Default: keine Vertauschung
        handles.colshift = [1,2,3];
        
        %Jede Zeile einer Spalte dieser Zelle bedeutet eine Zeile der 
        %Formel der Farbabbildung fr die zu dieser Spalte gehrenden Farbe
        %(3 Farben -> 3 Spalten)
        handles.holtra = cell(9,3);
        %Default: Identittsabbildung in erster Zeile
        handles.holtra(1,1:3) = {'x'};
        %Zhler, welche Zeile gerade angezeigt ist (fr jede Farbe extra)
        handles.holtrac = [1,1,1];
        %Zhler, wie viele Zeilen es gibt (fr jede Farbe extra)
        handles.trafos = [1,1,1];
        %Zhler, welcher Farbkanal gerade ausgewhlt ist (1,2 oder 3)
        handles.holtrarow = 1;
        %Zhler, wie lange die aktuelle Formelzeile ist (Anzahl an Zeichen)
        handles.rowleng = 0;

        %Hilfsvariable, um das popupmenu6 mit so vielen Eintrgen zu
        %fllen, wie es fr die aktuelle Farbe gerade Zeilen gibt
        handles.zeile = cell(9,1);

        for c = 1:9

            handles.zeile(c) = {['Zeile ',num2str(c)]};

        end

        set(handles.popupmenu6,'String','Zeile 1','Value',1);
        
        set(handles.popupmenu4,'Value',1);
        set(handles.popupmenu5,'Value',1);
        set(handles.popupmenu7,'Value',1);
        
        set(handles.edit21,'String','x');

    end
    
end