%FreakLab - imtransform_eigen.m
%
%Erstellt von Matthias Hasewend im Rahmen der bung 'Applikationssoftware
%fr Fortgeschrittene' bei Ass. Prof. Winfried Kernbichler, Institut fr
%Theoretische Physik / Computational Physics an der TU Graz im WS 2010/11.
%
%Beschreibung:
%
%In Anlehung an die Matlab-Routine imtransform, die fr die geometrischen
%Transformationen zustndig ist, fhrt diese selbstprogrammierte Routine
%Farbabbildung durch.

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function newim = imtransform_eigen(im,handles)
    
    %Farbdaten knnen uint8-Werte oder Fliekommazahlen im Bereich 0 bis 1
    %sein. In diesem Fall wird mit Letzterem gearbeitet
    
    %Auf Fliekommazahlen konvertiern
    im = double(im);
    %In Bereich 0 bis 1 normieren
    im = (im - min(im(:)))/(max(im(:)) - min(im(:)));
    
    newim = im;

    %Schleife ber Farbkanle
    for c = 1:3
        
        stri = [];

        %Schleife ber Formelzeilen
        for cc = 1:9

            %Formelzeile gewinnen
            stri2 = handles.holtra(cc,c);
            stri2 = cell2struct(stri2,{'stri2'},1);
            stri2 = stri2.stri2;
            %Zu Gesamtformel vereinen (fr einen Farbkanal)
            stri = [stri,stri2];

        end

        %Aus z.B. '*' ein '.*' machen
        stri = vectorize(stri);
        %Aus Formelstring eine Inlinefunktion machen
        trafo = inline(stri);

        %Vermeidung einer Division durch 0.
        trafo_div = @(x) trafo(x + 1e-10);
        
        %Formel fr diesen Farbkanal anwenden
        newim(:,:,c) = trafo_div(im(:,:,c));
        
    end
    

    %Wieder in Bereich 0 bis 1 normieren und eine Division durch 0
    %neuerlich vermeiden
    newim = real(newim);
    newim = (newim - min(newim(:)))/(max(newim(:)) - min(newim(:)) + 1e-10);
    
end